// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Wed Jul 14 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include "ArtCompressibleParabolicBSplitFlux2D.hh"

ArtCompressibleParabolicBSplitFlux2D::ArtCompressibleParabolicBSplitFlux2D(carg_t arg)
  : IncompressibleOperator2D(arg)
{
  AddClassName();
  x1 = arg.P->ReadReal();
  y1 = arg.P->ReadReal();
  x2 = arg.P->ReadReal();
  y2 = arg.P->ReadReal();
  vx = y2-y1;
  vy = -(x2-x1);
  real nabs = DIST(0,0,vx,vy);
  vx /= nabs;
  vy /= nabs;
  vmax = 1.5*DIST(0, 0, u_oo, v_oo);
  dp_dx = VL->Get1DVar("gradx", "p");
  dp_dy = VL->Get1DVar("grady", "p");
};

ArtCompressibleParabolicBSplitFlux2D::~ArtCompressibleParabolicBSplitFlux2D()
{
};

