// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include "BPOperation.hh"
#include <BPointCalculator.hh>

BPOperation::BPOperation(carg_t arg) : POperation(arg)
{
  AddClassName();
  BPL = FindObject<BoundaryPointList>(false, true);
  codes = new TList<code_t>(10, 10);
};

void BPOperation::InsertAllCodes()
{
  for (uint i = 0; i < BPL->NumCodes(); i++) {
    try {
      codes->FindItem(BPL->Code(i));
    }
    catch (NotFound_error) {
      codes->NewEntry() = BPL->Code(i);
    };
  };
};

void BPOperation::Act()
{
  if (!initialized) Error("'POperation' has not been initialized!");
  FORALL(i_code, codes->) {
    int c = codes->At(i_code);
    size_t i_begin = BPL->begin(c);
    size_t i_end;
    while (i_begin < BPL->end(c)) {
      i_end = i_begin + group_size;
      if (i_end > BPL->end(c)) i_end = BPL->end(c);
      BPointCalculator* bcalc = dynamic_cast<BPointCalculator*>(calc->At(0));
      bcalc->CalcGroup(c, codes, i_begin, i_end);
      i_begin = i_end;
    };
  };
};







