#include "Extensions1.hh"

#include <MultiGridAgent.hh>
#include <TFEdgeCalculator2D.hh>
#include <TBEdgeCalculator2D.hh>
#include <TPointCalculator.hh>
#include <TBPointCalculator.hh>
#include <OptimAggloMesh2D.hh>
#include <PopList2D.hh>
#include <MultiGridAveragedProlongation.hh>
#include <WriteAggloInfo.hh>
#include <StoredAggloMesh2D.hh>
#include <PrintFieldSum.hh>
#include <TestFromBoundary.hh>
#include <TestReduceBoundary.hh>
#include <SetVarToConst.hh>
#include <CompressibleBSplitFlux2D.hh>
#include <MultiplyFieldByConst.hh>
#include <MultiGridRestoreCoarse.hh>
#include <InitCorrectionDamper2D.hh>
#include <CorrectionDamper2D.hh>
#include <RepeatAction.hh>
#include <ComputeMaxRes.hh>
#include <ResCondition.hh>
#include <WriteMaxResToFile.hh>
#include <PrintMaxRes.hh>
#include <IsoMachValue2D.hh>
#include <CalcChDist2D.hh>
#include <VarDiffAdapt2D.hh>
#include <CompressibleCTWall2D.hh>
#include <CompressibleCSWall2D.hh>
#include <TWFlux.hh>
#include <Smoother2D.hh>
#include <AllocField.hh>
#include <TestProjector2D1.hh>
#include <TestProjector2D2.hh>
#include <EulerWall2D.hh>
#include <CompressibleBViscFlux2D.hh>
#include <ScFlux.hh>
#include <ScBoundaryFlux.hh>
#include <ScTimeStep.hh>
#include <DualTimeStepCorrection.hh>
#include <DualTimeStepSourceTerm.hh>
#include <RungeKuttaDts.hh>
#include <RungeKuttaDc.hh>
#include <SmoothingStep.hh>
#include <MgAllLevelCflManager.hh>
#include <VariCflManager.hh>
#include <InitResPrinter.hh>
#include <TurkelPrec2D.hh>
#include <ArtCompressibleRoe2D.hh>
#include <ArtCompressibleViscFlux2D.hh>
#include <ArtCompressibleBViscFlux2D.hh>
#include <ArtCompressibleBSplitFlux2D.hh>
#include <ArtCompressibleParabolicBSplitFlux2D.hh>
#include <CompressibleParabolicBSplitFlux2D.hh>
#include <ArtCompressibleWFlux2D.hh>
#include <IncompressibleSWall2D.hh>
#include <IncompressibleTWall2D.hh>
#include <IncompressibleTStep2D.hh>
#include <IncompressibleInit2D.hh>
#include <VarVectorValue.hh>
#include <IncompressibleVelocityIsoValue.hh>
#include <AggloMesh2D.hh>
#include <AnisoAggloMesh2D.hh>
#include <MultiGridLeastSquareProlongation.hh>
#include <ArtCompressibleFixPFlux2D.hh>
#include <CompressibleFixPFlux2D.hh>
#include <CoarseGridResToBoundary.hh>
#include <ComputeCoarseGridBoundaryGrad2D.hh>
#include <LoadBoundaries2D.hh>
#include <MergeGrid2D.hh>
#include <ChangeBCode.hh>
#include <ExtractBoundary2D.hh>
#include <EliminateEdges2D.hh>
#include <IncompressiblePressureExtrapolator2D.hh>
#include <IncompressibleVelocityVector2D.hh>
#include <IncompressibleAbsVelocity2D.hh>
#include <SetIncompressibleConstantPressure2D.hh>

void Extensions1::Register()
{
  new MObjectBuilder<OptimAggloMesh2D<PopList2D> >
    (MouseMain::Top(), "OptimAggloMesh2D");
  new MObjectBuilder<TPointCalculator<MultiGridAveragedProlongation<PopList2D> > >
    (MouseMain::Top(), "MultiGridAveragedProlongation");
  new MObjectBuilder<WriteAggloInfo<PopList2D> >
    (MouseMain::Top(), "WriteAggloInfo");
  new MObjectBuilder<StoredAggloMesh2D<PopList2D> >
    (MouseMain::Top(), "StoredAggloMesh2D");
  new MObjectBuilder<PrintFieldSum>
    (MouseMain::Top(), "PrintFieldSum");
  new MObjectBuilder<TBPointCalculator<TestFromBoundary<PopList2D> > >
    (MouseMain::Top(), "TestFromBoundary");
  new MObjectBuilder<TPointCalculator<TestReduceBoundary<PopList2D> > >
    (MouseMain::Top(), "TestReduceBoundary");
  new MObjectBuilder<TBPointCalculator<SetVarToConst> >
    (MouseMain::Top(), "SetBVarToConst");
  new MObjectBuilder<TPointCalculator<SetVarToConst> >
    (MouseMain::Top(), "SetFVarToConst");
  new MObjectBuilder<TBEdgeCalculator2D<CompressibleBSplitFlux2D, PopList2D> >
    (MouseMain::Top(), "CompressibleBSplitFlux2D");
  new MObjectBuilder<TBEdgeCalculator2D<CompressibleBViscFlux2D, PopList2D> >
    (MouseMain::Top(), "CompressibleBViscFlux2D");
  new MObjectBuilder<TPointCalculator<MultiplyFieldByConst> >
    (MouseMain::Top(), "MultiplyFieldByConst");
  new MObjectBuilder<InitCorrectionDamper2D>
    (MouseMain::Top(), "InitCorrectionDamper2D");
  new MObjectBuilder<TFEdgeCalculator2D<CorrectionDamper2D, PopList2D> >
    (MouseMain::Top(), "CorrectionDamper2D");
  new MObjectBuilder<RepeatAction>
    (MouseMain::Top(), "RepeatAction");
  new MObjectBuilder<ComputeMaxRes>
    (MouseMain::Top(), "ComputeMaxRes");
  new MObjectBuilder<ResCondition>
    (MouseMain::Top(), "ResCondition");
  new MObjectBuilder<WriteMaxResToFile>
    (MouseMain::Top(), "WriteMaxResToFile");
  new MObjectBuilder<PrintMaxRes>
    (MouseMain::Top(), "PrintMaxRes");
  new MObjectBuilder<IsoMachValue2D>
    (MouseMain::Top(), "IsoMachValue2D");
  new MObjectBuilder<CalcChDist2D<PopList2D> >
    (MouseMain::Top(), "CalcChDist2D");
  new MObjectBuilder<VarDiffAdapt2D<PopList2D> >
    (MouseMain::Top(), "VarDiffAdapt2D");
  new MObjectBuilder<TBPointCalculator<CompressibleCTWall2D> >
    (MouseMain::Top(), "CompressibleCTWall2D");
  new MObjectBuilder<TBPointCalculator<CompressibleCSWall2D> >
    (MouseMain::Top(), "CompressibleCSWall2D");
  new MObjectBuilder<TBEdgeCalculator2D<TWFlux, PopList2D> >
    (MouseMain::Top(), "TWFlux");
  new MObjectBuilder<TPointCalculator<Smoother2D<PopList2D> > >
    (MouseMain::Top(), "Smoother2D");
  new MObjectBuilder<AllocField>
    (MouseMain::Top(), "AllocField");
  new MObjectBuilder<TFEdgeCalculator2D<TestProjector2D1<PopList2D>, PopList2D> >
    (MouseMain::Top(), "TestProjector2D1");
  new MObjectBuilder<TFEdgeCalculator2D<TestProjector2D2<PopList2D>, PopList2D> >
    (MouseMain::Top(), "TestProjector2D2");
  new MObjectBuilder<TFEdgeCalculator2D<ScFlux, PopList2D> >
    (MouseMain::Top(), "ScFlux");
  new MObjectBuilder<TBEdgeCalculator2D<ScBoundaryFlux, PopList2D> >
    (MouseMain::Top(), "ScBoundaryFlux");
  new MObjectBuilder<TPointCalculator<ScTimeStep> >
    (MouseMain::Top(), "ScTimeStep");
  new MObjectBuilder<TPointCalculator<DualTimeStepCorrection<PopList2D> > >
    (MouseMain::Top(), "DualTimeStepCorrection");
  new MObjectBuilder<TPointCalculator<DualTimeStepSourceTerm<PopList2D> > >
    (MouseMain::Top(), "DualTimeStepSourceTerm");
  new MObjectBuilder<TBPointCalculator<EulerWall2D<PopList2D> > >
    (MouseMain::Top(), "EulerWall2D");
  new MObjectBuilder<RungeKuttaDts<PopList2D> >
    (MouseMain::Top(), "RungeKuttaDts");
  new MObjectBuilder<RungeKuttaDc<PopList2D> >
    (MouseMain::Top(), "RungeKuttaDc");
  new MObjectBuilder<SmoothingStep<PopList2D> >
    (MouseMain::Top(), "SmoothingStep");
  new MObjectBuilder<MgAllLevelCflManager<PopList2D> >
    (MouseMain::Top(), "MgAllLevelCflManager");
  new MObjectBuilder<VariCflManager>
    (MouseMain::Top(), "VariCflManager");
  new MObjectBuilder<InitResPrinter>
    (MouseMain::Top(), "InitResPrinter");
  new MObjectBuilder<TPointCalculator<TurkelPrec2D> >
    (MouseMain::Top(), "TurkelPrec2D");
  new MObjectBuilder<TPointCalculator<IncompressibleTStep2D> >
    (MouseMain::Top(), "IncompressibleTStep2D");
  new MObjectBuilder<TFEdgeCalculator2D<ArtCompressibleRoe2D, PopList2D> >
    (MouseMain::Top(), "ArtCompressibleRoe2D");
  new MObjectBuilder<TFEdgeCalculator2D<ArtCompressibleViscFlux2D, PopList2D> >
    (MouseMain::Top(), "ArtCompressibleViscFlux2D");
  new MObjectBuilder<TBEdgeCalculator2D<ArtCompressibleBViscFlux2D, PopList2D> >
    (MouseMain::Top(), "ArtCompressibleBViscFlux2D");
  new MObjectBuilder<TBEdgeCalculator2D<ArtCompressibleBSplitFlux2D, PopList2D> >
    (MouseMain::Top(), "ArtCompressibleBSplitFlux2D");
  new MObjectBuilder<TBEdgeCalculator2D<ArtCompressibleParabolicBSplitFlux2D, PopList2D> >
    (MouseMain::Top(), "ArtCompressibleParabolicBSplitFlux2D");
  new MObjectBuilder<TBEdgeCalculator2D<CompressibleParabolicBSplitFlux2D, PopList2D> >
    (MouseMain::Top(), "CompressibleParabolicBSplitFlux2D");
  new MObjectBuilder<TBEdgeCalculator2D<ArtCompressibleWFlux2D, PopList2D> >
    (MouseMain::Top(), "ArtCompressibleWFlux2D");
  new MObjectBuilder<TBEdgeCalculator2D<ArtCompressibleFixPFlux2D, PopList2D> >
    (MouseMain::Top(), "ArtCompressibleFixPFlux2D");
  new MObjectBuilder<TBEdgeCalculator2D<CompressibleFixPFlux2D, PopList2D> >
    (MouseMain::Top(), "CompressibleFixPFlux2D");
  new MObjectBuilder<TBPointCalculator<IncompressibleTWall2D> >
    (MouseMain::Top(), "IncompressibleTWall2D");
  new MObjectBuilder<TBPointCalculator<IncompressibleSWall2D> >
    (MouseMain::Top(), "IncompressibleSWall2D");
  new MObjectBuilder<TPointCalculator<IncompressibleInit2D> >
    (MouseMain::Top(), "IncompressibleInit2D");
  new MObjectBuilder<VarVectorValue>
    (MouseMain::Top(), "VarVectorValue");
  new MObjectBuilder<IncompressibleVelocityIsoValue>
    (MouseMain::Top(), "IncompressibleVelocityIsoValue");
  new MObjectBuilder<AnisoAggloMesh2D<PopList2D> >
    (MouseMain::Top(), "AnisoAggloMesh2D");
  new MObjectBuilder<AggloMesh2D<PopList2D> >
    (MouseMain::Top(), "AggloMesh2D");
  new MObjectBuilder<TPointCalculator<MultiGridLeastSquareProlongation<PopList2D> > >
    (MouseMain::Top(), "MultiGridLeastSquareProlongation");
  new MObjectBuilder<TBPointCalculator<CoarseGridResToBoundary<PopList2D> > >
    (MouseMain::Top(), "CoarseGridResToBoundary");
  new MObjectBuilder<TBPointCalculator<ComputeCoarseGridBoundaryGrad2D<PopList2D> > >
    (MouseMain::Top(), "ComputeCoarseGridBoundaryGrad2D");
  new MObjectBuilder<LoadBoundaries2D>
    (MouseMain::Top(), "LoadBoundaries2D");
  new MObjectBuilder<MergeGrid2D<PopList2D> >
    (MouseMain::Top(), "MergeGrid2D");
  new MObjectBuilder<ChangeBCode>
    (MouseMain::Top(), "ChangeBCode");
  new MObjectBuilder<ExtractBoundary2D<PopList2D> >
    (MouseMain::Top(), "ExtractBoundary2D");
  new MObjectBuilder<EliminateEdges2D>
    (MouseMain::Top(), "EliminateEdges2D");
  new MObjectBuilder<TBPointCalculator<IncompressiblePressureExtrapolator2D<PopList2D> > >
    (MouseMain::Top(), "IncompressiblePressureExtrapolator2D");
  new MObjectBuilder<IncompressibleVelocityVector2D>
    (MouseMain::Top(), "IncompressibleVelocityVector2D");
  new MObjectBuilder<IncompressibleAbsVelocity2D>
    (MouseMain::Top(), "IncompressibleAbsVelocity2D");
  new MObjectBuilder<TBPointCalculator<SetIncompressibleConstantPressure2D> >
    (MouseMain::Top(), "SetIncompressibleConstantPressure2D");
};
