#ifndef GenericSourceTerm_HH
#define GenericSourceTerm_HH

class GenericSourceTerm;

#include<Operator.hh>

/**
   a generic source term which will multiply a field by a scalar and add
   it to the residual field.
*/
class GenericSourceTerm : public Operator
{
protected:
  /** the field of the source term */
  VarContainer::var2_t var_source;

  /** the field of the residual */
  VarContainer::var2_t var_res;

  /** the factor to multiply the source field by */
  real factor;

public:
  /** */ GenericSourceTerm(carg_t arg);
  /** */ void operate(size_t i_tmp, size_t i);
};

inline void GenericSourceTerm::operate(size_t i_tmp, size_t i)
{
  for (size_t iv = 0; iv < VL->NumVars(); iv++) {
    var_res[iv][i] += factor * var_source[iv][i];
  };
};

#endif

