// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Thu May 20 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include "IsoMachValue2D.hh"

IsoMachValue2D::IsoMachValue2D(carg_t arg)
  : CompressiblePressureValue2D(arg)
{
  AddClassName();
};

IsoMachValue2D::~IsoMachValue2D()
{
};

void IsoMachValue2D::CalcValues()
{
  FORALL(i, PL->) {
    real p = (gamma-1) * (rhoE[i]-.5/rho[i]*(rhou[i]*rhou[i]+rhov[i]*rhov[i]));
    real a = sqrt(gamma*p/rho[i]);
    if (a < 1e-6) a = 1e-6;
    real u = sqrt(rhou[i]*rhou[i]+rhov[i]*rhov[i])/(rho[i]*rho[i]);
    plot_value->At(i) = u/a;
  };
};
