// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include "LoadPolygon2D.hh"
#include <fstream.h>

LoadPolygon2D::LoadPolygon2D(carg_t arg) : Mesh2DGeometryAction(arg)
{
  AddClassName();
  filename = arg.P->ReadString();
  filename += ".geom";
  code1 = arg.P->ReadInt();
  code2 = arg.P->ReadInt();
};

void LoadPolygon2D::Act()
{
  ifstream f(filename.c_str());
  size_t p0=0, p1=0, p2=0;
  real x0, y0, x1, y1;
  f >> x0 >> y0;
  if (f.fail()) Error("file format error");
  p1 = PL->AddEntry();
  MESH->FixPoint(p1);
  MESH->SetMatrixComp(p1, 0, 0, 0);
  MESH->SetNetDensity(p1, 0);
  PL->x(p1) = x0;
  PL->y(p1) = y0;
  PL->code(p1) = code1;
  p0 = p1;
  while (!f.eof()) {
    f  >> x1 >> y1;
    if (!f.fail()) {
      p2 = PL->AddEntry();
      MESH->FixPoint(p2);
      MESH->SetMatrixComp(p2, 0, 0, 0);
      MESH->SetNetDensity(p2, 0);
      PL->x(p2) = x1;
      PL->y(p2) = y1;
      PL->code(p2) = code2;
      TRI->AddFront(p2, p1);
      p1 = p2;
    };
  };
  TRI->AddFront(p0, p2);
};

