#include <mouse_config.h>
#ifdef WITH_QT

#include "MQMultiGridCellInfoPlotter.hh"
#include <qstring.h>
#include <qpainter.h>
#include <MQPlotWidget.hh>

MQMultiGridCellInfoPlotter::MQMultiGridCellInfoPlotter(ConstructArg arg, QWidget *parent,
						       const char *name) : 
  MQCellInfoPlotter(arg, parent, name)
{
  AddClassName();
  MultiGridAgent<PopList2D> *mga;
  mg_agents = new TList<MultiGridAgent<PopList2D>*>(5,5,NULL);
  while (!arg.P->eof()) {
    mga = ResolveVar<MultiGridAgent<PopList2D> >(arg);
    mg_agents->NewEntry() = mga;
  };
  try {
    mga = mg_agents->At(mg_agents->last());
    PL = mga->CoarsePL();
    POPL = mga->CoarsePOP();
  } catch (NotFound_error) {
    Error ("no MultiGridAgent found");
  };
};

void MQMultiGridCellInfoPlotter::AddBoundaryVectors(CellProjection2D *fcell, size_t i)
{
  MultiGridAgent<PopList2D> *mga = mg_agents->At(mg_agents->last())->Next();
  TList<size_t> *bp = mga->BoundaryPoints(i);
  if (bp != NULL){
    FORALL(j, bp->) {
      for (size_t k = 0; k < POPL->NumBLinks(bp->At(j)); k++) {
	fcell->AddVector(POPL->Bnx(bp->At(j),k), POPL->Bny(bp->At(j),k));
      };
    };
  };
};

#endif
