// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

/**********************************************************************

	--- Qt Architect generated file ---

	File: MQPlotWindow.hh
	Last generated: Tue Jul 21 13:02:43 1998

 *********************************************************************/

#ifndef MQPlotWindow_included
#define MQPlotWindow_included

#include <mouse_config.h>
#ifdef WITH_QT

class MQPlotWindow;

#include "MQPlotWindowData.hh"
#include <MQPlotWidget.hh>

class MQPlotWindow : public MQPlotWindowData, public MObject
{
  Q_OBJECT

protected:
  /** */ virtual void resizeEvent(QResizeEvent *E);
  /** */ MQPlotWidget *plot_widget;
  /** */ int panel_width;
  /** */ int panel_height;
  /** */ int left_margin;
  /** */ int right_margin;
  /** */ int top_margin;
  /** */ int bottom_margin;
  /** */ QPopupMenu *file_menu;
  /** */ QPopupMenu *view_menu;
  /** */ QPopupMenu *config_menu;
  /** */ QPopupMenu **plot_menu;
  /** */ int *plot_menu_id;
  /** */ int *config_menu_id;
  /** */ bool plot_option_checking;

protected slots:
  /** */ void ZoomXPP() { plot_widget->Zoom(50, 50); };
  /** */ void ZoomXMM() { plot_widget->Zoom(-100, -100); };
  /** */ void ZoomXP() { plot_widget->Zoom(5, 5); };
  /** */ void ZoomXM() { plot_widget->Zoom(-10, -10); };
  /** */ void Autoscale() { plot_widget->Autoscale(); };
  /** */ void StepUp() { plot_widget->Move(0, .1); };
  /** */ void StepDown() { plot_widget->Move(0, -.1); };
  /** */ void StepLeft() { plot_widget->Move(-.1, 0); };
  /** */ void StepRight() { plot_widget->Move(.1, 0); };
  /** */ void Redraw() { plot_widget->repaint(); };
  /** */ void CheckViewMenu(int id);
  /** */ void StartConfigDlg(int id);
  
public:
  /** constructor. */
  MQPlotWindow(ConstructArg arg, QWidget* parent = NULL, const char* name = NULL);
  
  /** destructor. */
  virtual ~MQPlotWindow();
};


#endif // MQPlotWindow_included
#endif







