// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include <mouse_config.h>
#ifdef WITH_QT

#include "MQPlotter.hh"

MQPlotter::MQPlotter(ConstructArg arg, QWidget *parent=0, const char *name=0) 
  : MQObject(arg, parent, name) 
{
  AddClassName();
  text = arg.P->ReadString();
};

void MQPlotter::Plot(MQPlotWidget *pw, QPainter *P, const QRect *R) 
{ 
  Abstract(); 
};

QDialog* MQPlotter::CreateConfigDlg(QWidget *parent) 
{ 
  return new StdConfigDlg(parent); 
};

void MQPlotter::PrintValue(MQPlotWidget *pw, QPainter *P, real x_r, real y_r, 
			   real value, string label = "")
{
  QString qs_label(label.c_str());
  QString qs_value;
  QString qs_print;
  qs_value.setNum(value);
  int x, y, w, h;
  if (label == "") qs_print = qs_value;
  else qs_print = qs_label + "=" + qs_value;
  pw->WorldToScreen(x_r, y_r, x, y);
  w = P->fontMetrics().width(qs_print);
  h = P->fontMetrics().height();
  x += h/2;
  y += h/2;
  P->setPen(white);
  P->setBrush(white);
  P->drawRect(x, y-h+2, w, h);
  P->setPen(black);
  P->drawText(x, y, qs_print);
}

#endif







