// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include <mouse_config.h>
#ifdef WITH_QT

#include "MQPointInfoPlotter.hh"
#include <qstring.h>
#include <qpainter.h>
#include <MQPlotWidget.hh>

MQPointInfoPlotter::MQPointInfoPlotter(ConstructArg arg, QWidget *parent, 
				       const char *name) : 
  MQPlotter(arg, parent, name)
{
  AddClassName();
  PL = FindObject<PointList>(false, true);
};

void MQPointInfoPlotter::DrawInfo(MQPlotWidget *pw, QPainter *P, 
				  PointList *PL, size_t i)
{
  QString a, b;
  int x, y, w, h;
  a.setNum(i);
  b.setNum(PL->code(i));
  a += ',';
  a += b;
  pw->WorldToScreen(PL->x(i), PL->y(i), x, y);
  w = P->fontMetrics().width(a);
  h = P->fontMetrics().height();
  x += h/2;
  y += h/2;
  P->setPen(white);
  P->setBrush(white);
  P->drawRect(x, y-h+2, w, h);
  P->setPen(black);
  P->drawText(x, y, a);
}

void MQPointInfoPlotter::Plot(MQPlotWidget *pw, QPainter *P, const QRect *R)
{
  for (size_t i = PL->First(); i < PL->NumEntries(); i = PL->Next(i)) {
    DrawInfo(pw, P, PL, i);
  };
};

#endif








