// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#if !defined(MQPOINTINFOPLOTTER_HH)
#define MQPOINTINFOPLOTTER_HH

#include <mouse_config.h>
#ifdef WITH_QT

class MQPointInfoPlotter;

#include <MQPlotter.hh>
#include <PointList.hh>

/**
   This plotter prints some point information on the screen.
*/
class MQPointInfoPlotter : public MQPlotter
{
  Q_OBJECT

protected:
  /** */ PointList *PL;
  /** */ void DrawInfo(MQPlotWidget *pw, QPainter *P, PointList *PL, size_t i);

public:
  /** */ MQPointInfoPlotter(ConstructArg arg, QWidget *parent=0, const char *name=0);
  /** */ virtual void Plot(MQPlotWidget *pw, QPainter *P, const QRect *R);
};

#endif
#endif







