// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#ifndef MQVectorPlotter_HH
#define MQVectorPlotter_HH

#include <mouse_config.h>
#ifdef WITH_QT

class MQVectorPlotter;

#include <MQPlotter.hh>
#include <VectorValue.hh>

class MQVectorPlotter : public MQPlotter
{
protected:
  /** */ PointList *PL;
  /** */ VectorValue **VEC;
  /** */ int num_vecs;
  /** */ int current_vec;
  /** */ bool PointInside(MQPlotWidget *pw, long int p, const QRect *rect);

public:
  /** */ bool fixed;
  /** */ bool scaled;
  /** */ real scale_factor;
  /** */ real fixed_length;
  /** */ MQVectorPlotter(ConstructArg arg, QWidget *parent=0, const char *name=0);
  /** */ virtual QDialog* CreateConfigDlg(QWidget *parent);
  /** */ int NumVecs() { return num_vecs; };
  /** */ VectorValue* VecV(int i) { return VEC[i]; };
  /** */ void SetVec(int i) { current_vec = i; };
  /** */ void CalcValues() { VEC[current_vec]->CalcValues(); };
  /** */ virtual void Plot(MQPlotWidget *pw, QPainter *P, const QRect *R);
};

#endif
#endif




