// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#if !defined(POperation_HH)
#define POperation_HH

class POperation;

#include <Action.hh>
#include <VarContainer.hh>
#include <TList.hh>
#include <PointCalculator.hh>
#include <PointList.hh>
#include <MouseMain.hh>

/** */ 
class POperation : public Action
{
  friend class PointCalculator;
  friend class BPOperation;

  /** */ bool initialized;

protected:
  /** */ void Init( size_t a_num_threads = 0, size_t a_group_size = 0);
  /** */ TList<VarContainer*> *edge_tmp;
  /** */ TList<VarContainer*> *point_tmp;
  /** */ TList<PointCalculator*> *calc;
  /** */ size_t num_threads;
  /** */ size_t group_size;
  /** */ PointList *PL;

  /** temporary help field for the construction process only */
  size_t current_thread;

public:
  /** */ POperation(ConstructArg arg);
  /** */ ~POperation();
  /** */ VarContainer* EdgeTmp(size_t thread_id) { return edge_tmp->At(thread_id); };
  /** */ VarContainer* PointTmp(size_t thread_id) { return point_tmp->At(thread_id); };
  /** */ size_t NumThreads() { return num_threads; };
  /** */ size_t GroupSize() { return group_size; };
  /** */ virtual void Act();
};

#endif







