// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!
#ifndef ScFlux_HH
#define ScFlux_HH

#include <ScOperator.hh>

class ScFlux : public ScOperator
{
protected:
  VarContainer::var1_t c_from, c_av, c_to;

public:
  ScFlux(carg_t arg);
  void operate(size_t ie, size_t ip, size_t from, size_t to, 
	       real nx, real ny, bool mod_from, bool mod_to);
};

inline void ScFlux::operate(size_t ie, size_t ip, size_t from, size_t to, 
			      real nx, real ny, bool mod_from, bool mod_to)
{
  real flux;
  real v_n = u*nx + v*ny;
  if (v_n > 0) flux = c_from[ie]*v_n;
  else flux = c_to[ie]*v_n;
  if (mod_from) c_res[from] -= flux;
  if (mod_to) c_res[to] += flux;
};

#endif

