// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Tue May 4 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!
#ifndef TwoFieldOperator_HH
#define TwoFieldOperator_HH

#include <mouse_config.h>

class TwoFieldOperator;

#include <mouse_types.hh>
#include <ConstructArg.hh>
#include <Operator.hh>

/**
   a base class for operators which operate on two fields (eg copy, add)
*/
class TwoFieldOperator : public Operator
{
protected:
  /** the name of the first field */
  string field_name1;

  /** the name of thee second field */
  string field_name2;

  /** a variable pointing to the first field */
  VarContainer::var2_t var1;

  /** a variable pointing to the second field */
  VarContainer::var2_t var2;

public:
  /** */ TwoFieldOperator (carg_t arg);
  /** */ virtual ~TwoFieldOperator ();
};


#endif
