// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include "VarList.hh"
#include <ConstructArg.hh>
#include <Parameter.hh>
#include <BroadcastEvent.hh>
#include <MStringList.hh>

//
//.. constructor
//
VarList::VarList (ConstructArg arg) : VarContainer(arg, false)
{ 
  AddClassName();

  // initialize the variable list
  PL = FindObject<PointList>(false, true);
  Init(PL);

#ifdef WITH_VAR3
  var = Get3DVar();
#endif

  // determine the variables used
  {
    /*
    string word = arg.P->ReadString();
    if (word != "vars") Error("'vars' expected");
    Parser *P = arg.P->SubParser();
    while (!P->eof()) AddVar(P->ReadString());
    */
    MStringList *vars;
    BuildObject(vars, arg);
    FORALL(i, vars->) AddVar(vars->At(i));
    delete vars;
  };

  // determine the fields used
  {
    /*
    string word = arg.P->ReadString();
    if (word != "fields") Error("'fields' expected");
    Parser *P = arg.P->SubParser();
    while (!P->eof()) AddField(P->ReadString());
    */
    MStringList *fields;
    BuildObject(fields, arg);
    FORALL(i, fields->) AddField(fields->At(i));
    delete fields;
  };

  /*
  Parameter *PARAM = FindObject<Parameter>(false, true);
  PARAM->InitVars(this);
  */
};
















