// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Wed May 19 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include "WriteMaxResToFile.hh"

WriteMaxResToFile::WriteMaxResToFile(carg_t arg)
  : Action(arg)
{
  AddClassName();
  VL = FindObject<VarList>(false, true);
  string filename = arg.P->ReadString();
  MRES = ResolveVar<ComputeMaxRes>(arg);
  s = new ofstream(filename.c_str());
  scale_max = new real[VL->NumVars()];
  scale_l2 = new real[VL->NumVars()];
  first_call = true;
};

WriteMaxResToFile::~WriteMaxResToFile()
{
};

void WriteMaxResToFile::Act()
{
  if (first_call) {
    first_call = false;
    for (size_t iv = 0; iv < VL->NumVars(); iv++) {
      scale_max[iv] = 1/MRES->MaxRes(iv);
      scale_l2[iv] = 1/MRES->L2Res(iv);
    };
  };
  for (size_t iv = 0; iv < VL->NumVars(); iv++) *s << scale_max[iv] * MRES->MaxRes(iv) << ' ';
  for (size_t iv = 0; iv < VL->NumVars(); iv++) *s << ' ' << scale_l2[iv] * MRES->L2Res(iv);
  *s << endl;
};
