// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!
#ifndef AggloMesh2DBasic_HH
#define AggloMesh2DBasic_HH

#include <BoundaryPointList.hh>
#include <ConstructArg.hh>
#include <MObject.hh>
#include <PointList.hh>
#include <PopList2D.hh>
#include <CoarsenMesh2D.hh>


/** */ 
template<class POP>
class AggloMesh2DBasic : public CoarsenMesh2D<POP>
{
protected:
  /** create the basic boudaries */
  void BuildBoundaries();

  /** construct the POP structure on the coarse grid. */
  void BuildPop();

  /** construct the agglomerated cells */ 
  virtual void Agglomerate()=0;

  /** compute the physical coordinates */
  virtual void ComputeCoordinates();

public:
  /** */ AggloMesh2DBasic(ConstructArg arg);
  /** */ void Setup();
};

#include "AggloMesh2DBasic.cc"

#endif

