// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include <TFEOperation2D.hh>
#include <TBEOperation2D.hh>

template<class POP>
CalcGradGreen2D<POP>::EvalGreenInt::EvalGreenInt(carg_t arg)
  : Grad2DOperator(arg) 
{ 
  AddClassName(); 
};

template<class POP>
CalcGradGreen2D<POP>::EvalBoundaryGreenInt::EvalBoundaryGreenInt(carg_t arg)
  : Grad2DOperator(arg) 
{ 
  AddClassName(); 
};

template<class POP>
CalcGradGreen2D<POP>::CorrectBoundaryGrad::CorrectBoundaryGrad(carg_t arg)
  : Grad2DOperator(arg) 
{ 
  AddClassName();
  //POPL = FindObject<POP>(false, true);
  FindObject(POPL, false, true);
};

template<class POP>
CalcGradGreen2D<POP>::CalcGradGreen2D(carg_t arg) : CalcGrad2D<POP>(arg)
{
  AddClassName();
  eval_green_int = new TFEOperation2D<EvalGreenInt,POP>(this);
  eval_b_green_int = new TBEOperation2D<EvalBoundaryGreenInt,POP>(this);
  eval_b_green_int->InsertAllCodes();
  correct_boundaries = new TBPOperation<CorrectBoundaryGrad,POP>(this);
  correct_boundaries->InsertAllCodes();
};

template<class POP>
void CalcGradGreen2D<POP>::Act()
{
  SetToZero();
  ToBoundary();
  EvalInt();
  FromBoundary();
  DivideByVol();
  //CorrectBoundaries();
};







