#ifndef EquiCartBlock2D_CC
#define EquiCartBlock2D_CC

template<class POP>
EquiCartBlock2D<POP>::EquiCartBlock2D(carg_t arg) : StructuredBlock2D<POP>(arg)
{
  AddClassName();
  size_t a_imax = arg.P->ReadIndex();
  size_t a_jmax = arg.P->ReadIndex();
  InitBlock(a_imax, a_jmax);
  real x_0 = arg.P->ReadReal(); 
  real y_0 = arg.P->ReadReal(); 
  real x_1 = arg.P->ReadReal();  
  real y_1 = arg.P->ReadReal();
  real dx = (x_1 - x_0)/(imax-1);
  real dy = (y_1 - y_0)/(jmax-1);
  for (size_t i=0; i<imax; i++) {
    for (size_t j=0; j<jmax; j++) {
      Set(i, j, x_0+i*dx, y_0+j*dy);
    };
  };
  AddEdgesToPop();
};

#endif
