#ifndef FindMinMax_HH
#define FindMinMax_HH

#include <geometry2D.hh>
#include <math.h>

typedef double real;

/**
   a tool to find extreme values of a function.
*/
template<class F>
class FindMinMax
{
  /** */ F *f;
  /** */ real delta_x;
  /** */ real d_x;
  /** */ real x_max;
  /** */ real f_min;
  /** */ real f_max;
  /** */ real fx_min;
  /** */ real fx_max;
  /** */ real prec;
  /** */ int steps;
  /** */ real ComputeValues(real x0, real x1, real x2, real &f0, real &f1, real &f2);
  /** */ bool Advance(real &x0);

public:
  /** */ FindMinMax(F *an_f, real an_x_min, real an_x_max, int N, real a_prec);
  /** */ real Max() { return f_max; };
  /** */ real Min() { return f_min; };
  /** */ real XMax() { return fx_max; };
  /** */ real XMin() { return fx_min; };
  /** */ int Steps() { return steps; };
};

#include "FindMinMax.cc"

#endif
