#ifndef MultiGridCoarseGridSetup_HH
#define MultiGridCoarseGridSetup_HH

template<class POP> class MultiGridCoarseGridSetup;

#include <Action.hh>
#include <VarList.hh>
#include <SetFieldToZero.hh>

template<class POP>
class MultiGridCoarseGridSetup : public Action
{
protected:
  /** an operator to compute the source term */
  struct ComputeSource : public Operator
  {
    ComputeSource(carg_t arg);
    VarContainer::var2_t source;
    VarContainer::var2_t res;
    void operate(size_t i_tmp, size_t i);
  };

  /** an Action, using the above 'ComputeSource' operator */
  Action *compute_source;

  /** an Action to compute the residual on the coarse grid */
  Action *compute_res;

public:
  /** */ MultiGridCoarseGridSetup(carg_t arg);
  /** */ virtual void Act();

  /**
     get the source term for a coarse grid point;
  */ 
  real SourceTerm(size_t i) { return source_term->At(i); };
};

template<class POP>
inline void MultiGridCoarseGridSetup<POP>::ComputeSource::operate
(size_t i_tmp, size_t i)
{
  for (size_t iv = 0; iv < VL->NumVars(); iv++) {
    source[iv][i] += res[iv][i];
  };
};

#include "MultiGridCoarseGridSetup.cc"

#endif
