// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Mon May 17 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!
#ifndef MultiGridRestoreCoarse_HH
#define MultiGridRestoreCoarse_HH

#include <mouse_config.h>

template <class POP> class MultiGridRestoreCoarse;

#include <mouse_types.hh>
#include <ConstructArg.hh>
#include <MultiGridTransferOperator.hh>

/**
*/
template <class POP>
class MultiGridRestoreCoarse : public MultiGridTransferOperator<POP>
{
protected:
  /** */ VarContainer::var2_t old_var;

public:
  /** */ MultiGridRestoreCoarse (carg_t arg);
  /** */ virtual ~MultiGridRestoreCoarse ();
  /** */ void operate(size_t i_tmp, size_t i_fine);
};

template<class POP>
inline void MultiGridRestoreCoarse<POP>::operate(size_t i_tmp, size_t i_fine)
{
  if (TransferPoint(i_fine)) {
  };
};


#include "MultiGridRestoreCoarse.cc"

#endif
