#ifndef MultiGridTransferToFine_HH
#define MultiGridTransferToFine_HH

template<class POP> class MultiGridTransferToFine;

#include <MultiGridResetCoarse.hh>
#include <MultiGridRestriction.hh>
#include <MultiGridProlongation.hh>
#include <Action.hh>

template<class POP>
class MultiGridTransferToFine : public Action
{
protected:
  /**
     the agent handling this pair of grids
  */
  MultiGridAgent<POP> *mg_agent;

  /**
     an Action to subtract the restricted fine variables from the
     computed coarse ones
  */
  Action *restr_new;

  /**
     an Action to prolongate the result of the above substraction
     to the fine grid
  */
  Action *prolong_new;

public:
  /** */ MultiGridTransferToFine(carg_t arg);
  /** */ virtual void Act();
};

#include "MultiGridTransferToFine.cc"

#endif
