#ifndef MultiGridWeightedRestriction_HH
#define MultiGridWeightedRestriction_HH

template<class POP> class MultiGridWeightedRestriction;

#include <MultiGridTransferOperator.hh>

/**
   a transfer operator to get a vector from a fine to a coarse grid
*/
template<class POP>
class MultiGridWeightedRestriction : public MultiGridTransferOperator<POP>
{
public:
  /** */ MultiGridWeightedRestriction(carg_t arg) : MultiGridTransferOperator<POP>(arg) { 
    AddClassName(); 
  };

  /** */ void operate(size_t i_tmp, size_t i_fine);
};

template<class POP>
inline void MultiGridWeightedRestriction<POP>::operate(size_t i_tmp, size_t i_fine)
{
  if (TransferPoint(i_fine)) {
    size_t i_coarse = mg_agent->CoarsePoint(i_fine);
//     cout << mg_agent << " " << i_fine << " " << i_coarse << endl;
    for (size_t i_var = 0; i_var < VL->NumVars(); i_var++) {
      var_coarse[i_var][i_coarse] += var_fine[i_var][i_fine] * factor
	* PL_fine->Vol(i_fine) * PL_coarse->IVol(i_coarse);
    };
  };
};

#endif
