// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik
// Universitaet Duisburg, Germany
// Institute for Combustion and Gas Dynamics
// University of Duisburg, Germany
// Fri Jun 11 1999
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#include "RungeKuttaDts.hh"

#ifndef RungeKuttaDts_CC
#define RungeKuttaDts_CC

template <class POP>
RungeKuttaDts<POP>::RungeKuttaDts(carg_t arg)
  : RungeKutta<POP>(arg)
{
  AddClassName();
  //CFLM_IMPL = ResolveVar<MgAllLevelCflManager<POP> >(arg);
  ResolveVar(CFLM_IMPL, arg);
  //MultiGridAgent<POP> *mga = FindObject<MultiGridAgent<POP> >(false, true);
  MultiGridAgent<POP> *mga;
  FindObject(mga, false, true);
  partial_dts_step = new TPOperation<RungeKuttaDts<POP>::DtsPartialStep, POP>(this);
};

template <class POP>
RungeKuttaDts<POP>::~RungeKuttaDts()
{
};

template<class POP>
RungeKuttaDts<POP>::DtsPartialStep::DtsPartialStep(carg_t arg) : SubOperator(arg)
{
  AddClassName();
  //rkdts = FindObject<RungeKuttaDts<POP> >(true, true);
  FindObject(rkdts, true, true);
  CFLM_IMPL = rkdts->ImplCfl();
};

template<class POP>
void RungeKuttaDts<POP>::Act()
{
  Copy();
  is_first = true;
  FORALL(i, alpha->) {
    factor = alpha->At(i);
    CalcGrad();
    SetRes();
    Before();
    Partial();
    is_first = false;
    After();
  };
};

#endif

