#ifndef SetFieldToZero_HH
#define SetFieldToZero_HH

template<class POP> class SetFieldToZero;

#include <TPOperation.hh>
#include <VarList.hh>
#include <Action.hh>

/**
   This Action can be used to set a field of the 'VarList' to 0.
*/
template<class POP>
class SetFieldToZero : public Action
{
protected:
  /** an operator to set a field to zero */
  struct SetZero : public Operator {
    VarContainer::var2_t var;
    SetZero(carg_t arg) : Operator(arg) {
      AddClassName();
      var = VL->Get2DVar(arg.P->ReadString());
    };
    void operate (size_t i_tmp, size_t i) {
      for (size_t iv=0; iv < VL->NumVars(); iv++) var[iv][i] = 0;
    };
  };

  /** an Action using this operator */
  Action *set_to_zero;

public:
  /** */ SetFieldToZero(carg_t arg);
  /** */ virtual void Act();
};

#include "SetFieldToZero.cc"

#endif
