// !!
// This is a part of MOUSE, a library for PDE's on unstructured grids
// Copyright (C) 1999 Oliver Gloth <oliver@vug.uni-duisburg.de>
// Institut fuer Verbrennung und Gasdynamik (Universitaet Duisburg)
// institute for combustion and gas dynamics (university of Duisburg)
// Thursday, 1 April, 1999 Duisburg, Germany
//
// please see http://www.vug.uni-duisburg.de/MOUSE for more information
// please send any questions or suggestions to mouse@www.vug.uni-duisburg.de
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// !!

#if !defined(TMDIMINDEX_H)
#define TMDIMINDEX_H

template <class TIndex> class TMDimIndex;

#include <iostream.h>
#include <string>

/**
   a multidimensional symbolic index.
*/
template<class TIndex>
class TMDimIndex
{
protected:
  /** */ int dim;
  /** */ TIndex *I;

public:
  /** */ TMDimIndex(int a_dim);
  /** */ TMDimIndex();
  /** */ TMDimIndex(TIndex item);
  /** */ void Resize(int a_dim);
  /** */ void operator=(TMDimIndex<TIndex> other);
  /** */ void operator=(TIndex item);
  /** */ bool operator==(const TMDimIndex<TIndex> other) const;
  /** */ TMDimIndex<TIndex> operator+(const TIndex item); 
  /** */ TIndex& operator[](int i) { return I[i]; };
  /** */ TIndex operator[](int i) const { return I[i]; };
  /** */ int Dim() const { return dim; };
  /** */ template<class aTIndex>
  friend ostream& operator<< (ostream& s, const TMDimIndex<aTIndex>& I);
};

template<class TIndex> ostream& operator<< (ostream& s, const TMDimIndex<TIndex>& I);

#include "TMDimIndex.cc"

#endif








